Skip to main content

Universal Submit V5 (SmartUpload)

Description​

Universal Submit v5 (Smart Upload) is a specialized version of the Universal Submission API designed to accelerate submission processing by bypassing complex orchestration workflows without compromising processing quality.

This API supports a limited set of document types and is optimized for smaller files containing fewer than 15 pages. Submissions that meet these criteria can leverage the streamlined processing workflow for faster turnaround times.

Supported document types are: EML, MKTP, ACORD, APP_FORM, POLICY_FORMS, LOSS_RUN, SCHEDULE_ITEMS, QUOTE_SLIP, QUOTE

Universal Submit v5 (Smart Upload) supports the following file extensions: .eml, .msg, .pdf, .doc, .docx, and .zip. ZIP files may contain files with any of the supported extensions listed above.

Authentication and Credentials​

Obtain a Bearer Token

The Universal Submit V5 API uses the Insurance Intelligence Authenticate API to obtain a bearer token using your client_id, client_secret, and API key. The bearer token obtained from the Authentication API can be used to authenticate requests using the Universal Submit API.

Your Bold Penguin project team will provide you with a unique client_id and client_secret for each environment as well as an API key and Data Package ID (dp_id).

Accessing the Universal Submit V5 API​

Obtain File Upload URL

  • The call to the below endpoint will return a URL where the file can be uploaded.
  • The URL is valid for 5 minutes
  • The tx_id returned as part of the response is required to communicate with submit, status check, and inquiry APIs in the context of the submission.

Endpoint​

Staging​

https://api-smartdata.di-beta.boldpenguin.com/universal/v5/universal-submit/file-upload-url

Production​

https://api.ii.boldpenguin.com/universal/v5/universal-submit/file-upload-url

Pass the following variables as part of the request

Request ParametersDescription
Authentication TokenThe token obtained via the Authentication API
API KeyProvided by Bold Penguin
filenameFull name including extension of the file that is being uploaded
x-orgReferenceIdSubtenant id, Optional header Param. to proces the request using this id.

Sample File Upload URL Request​

POST /universal/v5/universal-submit/file-upload-url 
Host: api-smartdata.di-beta.boldpenguin.com
x-api-key: xxxxxxxxxxxxxxxxxx
Authorization: Bearer xxxxxxxxxxxxxxxxxx
Content-Type: application/json
Content-Length: 70

{
"filename":"Your_Test_File.eml"
}

Sample File Upload URL Response​

{
"tx_id": "ca7496f7-a933-48d5-bccf-b1dd10f2b9e6",
"upload_url": "https://plb.di-beta.boldpenguin.com/file-transfer/upload-file?data=AAAAuAECAwB4KBTA570fKFbYe1Mk3uskjyVUYNCRanx2YpT7T1sYaigBlA1trG8UX%2BFBHhxdQ3IoDgAAAH4wfAYJKoZIhvcNAQcGoG8wbQIBADBoBgkqhkiG9w0BBwEwHgYJYIZIAWUDBAEuMBEEDJgGaPjP3tnH9pTYAAIBEIA7LwAtmiX4MtCIyxhTNHeodgNHM2drgOYnvRLhqGhG8sKRa2Kc6YTePGfW6YSq7KNYVDqNDLkFMbVAKN5nQUFBQUFCaE1qQ2dvQ06jVnpiSTFCeDdVT2tIMk1Pd01lbWhtOVNWclF0TmxpekFsazRoeThEZng1X1ZmeTZjVHhNeUp0ckFLLUpxUGpMeUhUcjVIUU1WR21seHJ6cE9tQnBGZjA1WFpleFdoRDZFVVRqMDhydnhhQWZSMzNDWlJEM1FMdW5jSVRMdkJJeHM5TDNWMlVvbGpGbUFncGNzTWRfUTJUVFRHQXY0ZmtyVjMzNXJRRzY1dW5nSFhQTEhmU29KUWVsWmRvelJtM1NMcTdmU3JteWxmTHZMeDTNWTJkTHdVMEtoeC03V3ZCV08xNG9xaG9zOU9GWWUwc1d2QU1aOHVFTG45T3dXQ0hlZEFGN2hsRXFjbmxlUTJhdG44SWRvY0wwT0JEdm14dTBVQWg5c21yQnZIYXZoczE3MTk4VUI5M3owMVhmRkJFMkNkSXo3MmZvUWpYUmJsb254NFl5LTVDWHpVVFdpQzV3NE10ZW9qdVE9"
}

Upload the File

Use the upload_url obtained in the Upload URL Request to send the file.

Sample File Upload Request​

PUT /file-transfer/upload-file?data=AAAAuAECAwB4KBTA570fKFbYe1Mk3uskjyVUYNCRanx2YpT7T1sYaigBlA1trG8UX%2BFBHhxdQ3IoDgAAAH4wfAYJKoZIhvcNAQcGoG81bQIBADBoBgkqhkiG9w0BBwEwHgYJYIZIAWUDBAEuMBEEDJgGaPjP3tnH9pTYAAIBEIA7LwAtmiX4MtCIyxhTNHeodgNHM2drgOYnvRLhqGhG8sKRa2Kc6YTePGfW6YSq7KNYVDqNDLkFMbVAKN5nQUFBQUFCaE1qQ2dvQ0ZjVnpiSTFCeDdVT2tIMk1Pd01lbWhtOVNWclF0TmxpekFsazRoeThEZng1X1ZmeTZjVHhNeUp0ckFLLUpxUGpMeUhUcjVIUU1WR21seHJ6cE9tQnBGZjA1WFpleFdoRDZFVVRqMDhydnhhQWZSMzNDWlJEM1FMdW5jSVRMdkJJeHM5TDNWMlVvbGpGbUFncGNzTWRfUTJUVFRHQXY0ZmtyVjMzNXJRRzY1dW5nSFhQTEhmU29KUWVsWmRvelJtM1NMcTdmU3JteWxmTHZMeDNNWTJkTHdVMEtoeC03V3ZCV08xNG9xaG9zOU9GWWUwc1d2QU1aOHVFTG45T3dXQ0hlZEFGN2hsRXFjbmxlUTJhdG44SWRvY0wwT0JEdm14dTBVQWg5c21yQnZIYXZoczE3MTk4VUI5M3owMVhmRkJFMkNkSXo3MmZvUWpYUmJsb254NFl5LTVDWHpVVFdpQzV3NE10ZW9qdVE9 HTTP/1.1
Host: plb.di-beta.boldpenguin.com
Content-Length: 231
Content-Type: multipart/form-data; boundary=----WebKitFormBoundary7MA4YWxkTrZu0gW

----WebKitFormBoundary7MA4YWxkTrZu0gW
Content-Disposition: form-data; name="file"; filename="Your_Test_File.eml"
Content-Type: <Content-Type header here>

(data)
----WebKitFormBoundary7MA4YWxkTrZu0gW

Sample File Upload Request Response​

{
"data": "s3://<bucket-name>",
"input_file_name": "Your_Test_File.eml",
"input_file_size": "119516 bytes",
"tx_id": "1e8ec595-32ef-4fcc-bc5f-36b8034516af"
}

Trigger the File Processing Flow

If the document is pre-classified, then some processing time can be saved by passing the document_type as part of the request. If the document is not pre-classified, the flow tries to classify the document first before the processing starts. Below listed are the endpoints for these two variations

Endpoint​

Staging​

https://api-smartdata.di-beta.boldpenguin.com/universal/v5/universal-quick-submit/file/{tx_id}

Production​

https://api.ii.boldpenguin.com/universal/v5/universal-quick-submit/file/{tx_id}

Pass the following variables as part of the request

Request ParametersDescription
Authentication TokenThe token obtained via the Authentication API
API KeyProvided by Bold Penguin
tx_idThe tx_id returned as part of the get file upload URL request
document_type (Optional)pre-classified doc_type, should be one of supported doc_type provided above
dpid (Optional)Query parameter to send the company data package ID for company enrichment
location_dp_id (Optional)Query parameter to send the location data package ID for location enrichment
x-callback-url (Optional)This is an optional header parameter. The endpoint where the document processing completion notification needs to be pushed
x-auth-url (Optional)The endpoint to get the authentication token for communicating with the call back API. The prerequisite here is that the credentials to get the token are configured within the system
x-orgReferenceId (Optional)Subtenant id, to proces the request using this id. This should match with the value passed at 1st reqeust.

Sample Universal Submit Request​

POST /universal/v5/universal-quick-submit/file/1e8ec595-32ef-4fcc-bc5f-36b8034516af 
Host: api-smartdata.di-beta.boldpenguin.com
x-api-key: xxxxxxxxxxxxxxxxxx
Authorization: Bearer xxxxxxxxxxxxxxxxxx

Sample Universal Submit Response​

{
"submission_id": "1e8ec595-32ef-4fcc-bc5f-36b8034516af",
"submitted_date": "2026-10-24T20:17:09.292821+00:00",
"completed_date": "2026-10-24T20:17:09.457894+00:00",
"response_time_secs": 0.165073,
"tenant_id": "kowalski",
"user_id": "0715308c-db1c-4e63-b854-779bc93bc77c",
"submission_status": "Scheduled"
}

Submission Flow​

Submission_in_progress -> Scheduled -> Started -> Review_required -> Completed or Failed.

Accessing the Universal Submit Status Check API​

Once the file has been submitted for processing, the submission flow status can be checked using the Universal Submit Status Check API.

Endpoint​

Staging​

https://api-smartdata.di-beta.boldpenguin.com/universal/v5/universal-submit/status/{tx_id}

Production​

https://api.ii.boldpenguin.com/universal/v5/universal-submit/status/{tx_id}

Pass the following variables as part of the request

Request ParametersDescription
Authentication TokenThe token obtained via the Authentication API
API KeyProvided by Bold Penguin
tx_idThis ID is returned as part of the Universal Submit response

Sample Universal Submit Status Check Request​

GET /universal/v5/universal-submit/status/1e8ec595-32ef-4fcc-bc5f-36b8034516af 
Host: api-smartdata.di-beta.boldpenguin.com
x-api-key: xxxxxxxxxxxxxxxxxxxxxxx
Authorization: Bearer 5ZhAzSrQCuyYct367GqfSnwE

Sample Universal Submit Status Check Response​

{
"submission_id": "1e8ec595-32ef-4fcc-bc5f-36b8034516af",
"tenant_id": "kowalski",
"tenant_uid": "96a5f17b-ebc8-4459-aca7-b49ba6fbc752",
"user_id": "0715308c-db1c-4e63-b854-779bc93bc77c",
"submission_status": "Started",
"submitted_date": "2026-10-24T20:17:09.292000",
"submitted_documents": {
"seed_file_name": "25 ACORD GL App - unsigned.pdf"
},
"document_processing": {
"tx_status": "Review_required",
"total_time": 80.838101,
"start_time": "2026-10-24T20:17:09.292000",
"completed_time": "2026-10-24T20:18:30.130000",
"errors": []
},
"quote_application": {
"application_id": "0f161b34-16f5-4eea-be1a-b456d60a37bf",
"app_ref_id": "847-8GK-2GW",
"application_status": "in_progress",
"application_status_reason": null,
"tx_status": "Started",
"start_time": "2026-10-24T20:17:57.010000"
},
"quote_details": [],
"document_embeddings": {
"status": "Succeeded",
"start_time": "2026-10-24T20:17:10.291000",
"completed_time": "2026-10-24T20:18:18.344000",
"total_time": 68.034917
}
}

The status will change from Submission_in_progress and move through to Started and then it will be Completed, Review_required or Failed. There will also be a c_report_id and l_report_id generated on successful submission of data for enrichment

Accessing the Universal Submit Status Details API​

You can access details of a submission to the Universal Submit API by providing the appropriate tx_id.

Endpoint​

Staging​

https://api-smartdata.di-beta.boldpenguin.com/universal/v5/universal-submit/status/{tx_id}/details

Production​

https://api.ii.boldpenguin.com/universal/v5/universal-submit/status/{tx_id}/details
Request ParametersDescription
Authentication TokenThe token obtained via the Authentication API
API KeyProvided by Bold Penguin
tx_idThis ID is returned as part of the Universal Submit response

Sample Universal Submit Status Details Request​

GET /universal/v5/universal-submit/status/ca7496f7-a933-48d5-bccf-b1dd10f2b9e6/details 
Host: api-smartdata.di-beta.boldpenguin.com
x-api-key: xxxxxxxxxxxxxxxxxxxx
Authorization: Bearer xxxxxxxxxxxxxxxxxxxx

Sample Universal Submit Status Details Response​

{
"submission_id": "1e8ec595-32ef-4fcc-bc5f-36b8034516af",
"tenant_id": "kowalski",
"tenant_uid": "96a5f17b-ebc8-4459-aca7-b49ba6fbc752",
"user_id": "0715308c-db1c-4e63-b854-779bc93bc77c",
"submission_status": "Started",
"submitted_date": "2026-10-24T20:17:09.292000",
"submitted_documents": {
"seed_file_name": "25 ACORD GL App - unsigned.pdf",
"documents": [
{
"document_id": "dc5d28ec-2c60-4bc8-a24d-7bcf9eb48f5d",
"document_name": "25 ACORD GL App - unsigned.pdf"
}
]
},
"document_processing": {
"tx_status": "Review_required",
"total_time": 80.838101,
"start_time": "2026-10-24T20:17:09.292000",
"completed_time": "2026-10-24T20:18:30.130000",
"errors": [],
"documents": [
{
"document_id": "dc5d28ec-2c60-4bc8-a24d-7bcf9eb48f5d",
"document_name": "25 ACORD GL App - unsigned.pdf",
"errors": [],
"classified_documents": [
{
"document_id": "6b92476d-1555-4eb0-93f7-69073a9d3597",
"document_name": "25 ACORD GL App - unsigned_acord.pdf",
"document_type": "ACORD",
"number_of_pages_or_sheets": 11,
"startTime": "2026-10-24T20:17:23.719000",
"status": "Review_required",
"extraction_status": "Review_required",
"endTime": "2026-10-24T20:17:45.839000"
}
],
"document_language": [
"en"
],
"is_translated": false,
"classified_document_count": 1
}
],
"total_number_of_documents": 1,
"total_number_of_pages": 11,
"total_number_of_rows_processed": 0
},
"quote_application": {
"application_id": "0f161b34-16f5-4eea-be1a-b456d60a37bf",
"app_ref_id": "847-8GK-2GW",
"application_status": "in_progress",
"application_status_reason": "Missing Questions: ['carrier_trade_assc_cd', 'carrier_DG229_1', 'carrier_DG229_1', 'carrier_DG229_1']",
"tx_status": "Completed",
"start_time": "2026-10-24T20:17:57.010000",
"completed_time": "2026-10-24T20:21:47.075000",
"total_time": 230.065401
},
"quote_details": [
{
"products": [
"General Liability"
],
"status": "incomplete_questions",
"carrier_name": "Kowalski",
"carrier_code": "kowalskicarrier",
"status_reasons": [
"Missing Questions: carrier_trade_assc_cd ,carrier_DG229_1 ,carrier_DG229_1 ,carrier_DG229_1"
],
"missing_questions": [
"carrier_trade_assc_cd",
"carrier_DG229_1",
"carrier_DG229_1",
"carrier_DG229_1"
]
}
],
"document_embeddings": {
"status": "Succeeded",
"start_time": "2026-10-24T20:17:10.291000",
"completed_time": "2026-10-24T20:18:18.344000",
"total_time": 68.034917
}
}

Supported Error Codes​

Error CategoryHTTP Error CodeError CodeError Description
SECURITY_ERROR401Unauthorized
403Access Forbidden
429RATE_LIMIT_REACHED
BAD_REQUEST400ERR_0100INVALID_INPUT
ERR_0101INVALID_INPUT_SIZE_EXCEEDS_RANGE
ERR_0102UNSUPPORTED_MEDIA_TYPE
ERR_0103MISSING_MANDATORY_INPUT
ERR_0104DATA_NOT_FOUND
INTERNAL_SERVER500ERR_0200INTERNAL_SERVER
ERR_0201INTEGRATION_ERROR
ERR_0202CONNECTION_ERROR
ERR_0203TIMEOUT_ERROR
ERR_0204IO_ERROR
ERR_0205DB_ERROR
ERR_0300DOC_PROCESSING_ERROR
ERR_0301DOC_CLASSIFICATION_ERROR
ERR_0302DOC_EXTRACTION_ERROR
ERR_0303DATA_ENRICHMENT_ERROR
ERR_0401AI_CLEANSER_ERROR
ERR_0402AI_MATCHER_ERROR
SERVICE_UNAVAILABLE503

Callback Endpoints​

Prerequisites​

The client will provide a callback endpoint to which notifications are pushed. To access the secured API, the client will share the API details and credentials for both authentication and the callback API. Upon receipt of this information, the Bold Penguin team will configure the details in the Bold Penguin system and enable callback notifications.

Triggering the Notifications​

  1. Client prerequisites
    • The client must expose a callback endpoint for SubmissionLink to push notifications to.
    • Since the callback API will be secured, an authentication URL is also required to obtain the auth token or static API key.
  2. Bold Penguin SubmissionLink configuration
    • Once the authentication and callback endpoint details are shared, the tenant configuration is updated in SubmissionLink.
  3. Universal Submit API call
    • Pass the callback URL and auth URL as header parameters in the Universal Submit API call.

Sample Universal Submit Request with Callback​

POST /universal/v5/universal-submit/file/{tx_id} HTTP/1.1
Host: api-smartdata.di-beta.boldpenguin.com
x-api-key: xxxxxxxxxxx
x-callback-url: https://<host_name>/notification
x-auth-url: https://<host_name>/authentication
Authorization: Bearer xxxxxxxxx

Sample Push Notification​

Below is a sample push notification for the Review_required event.

{
"submission_id": "1e8ec595-32ef-4fcc-bc5f-36b8034516af",
"tenant_id": "kowalski",
"tenant_uid": "96a5f17b-ebc8-4459-aca7-b49ba6fbc752",
"user_id": "0715308c-db1c-4e63-b854-779bc93bc77c",
"submission_status": "Started",
"submitted_date": "2026-10-24T20:17:09.292000",
"submitted_documents": {
"seed_file_name": "25 ACORD GL App - unsigned.pdf",
"documents": [
{
"document_id": "dc5d28ec-2c60-4bc8-a24d-7bcf9eb48f5d",
"document_name": "25 ACORD GL App - unsigned.pdf"
}
]
},
"document_processing": {
"tx_status": "Review_required",
"total_time": 80.838101,
"start_time": "2026-10-24T20:17:09.292000",
"completed_time": "2026-10-24T20:18:30.130000",
"errors": [],
"documents": [
{
"document_id": "dc5d28ec-2c60-4bc8-a24d-7bcf9eb48f5d",
"document_name": "25 ACORD GL App - unsigned.pdf",
"errors": [],
"classified_documents": [
{
"document_id": "6b92476d-1555-4eb0-93f7-69073a9d3597",
"document_name": "25 ACORD GL App - unsigned_acord.pdf",
"document_type": "ACORD",
"number_of_pages_or_sheets": 11,
"startTime": "2026-10-24T20:17:23.719000",
"status": "Review_required",
"extraction_status": "Review_required",
"endTime": "2026-10-24T20:17:45.839000"
}
],
"document_language": [
"en"
],
"is_translated": false,
"classified_document_count": 1
}
],
"total_number_of_documents": 1,
"total_number_of_pages": 11,
"total_number_of_rows_processed": 0
},
"quote_application": {
"application_id": "0f161b34-16f5-4eea-be1a-b456d60a37bf",
"app_ref_id": "847-8GK-2GW",
"application_status": "in_progress",
"application_status_reason": "Missing Questions: ['carrier_trade_assc_cd', 'carrier_DG229_1', 'carrier_DG229_1', 'carrier_DG229_1']",
"tx_status": "Completed",
"start_time": "2026-10-24T20:17:57.010000",
"completed_time": "2026-10-24T20:21:47.075000",
"total_time": 230.065401
},
"quote_details": [
{
"products": [
"General Liability"
],
"status": "incomplete_questions",
"carrier_name": "Kowalski",
"carrier_code": "kowalskicarrier",
"status_reasons": [
"Missing Questions: carrier_trade_assc_cd ,carrier_DG229_1 ,carrier_DG229_1 ,carrier_DG229_1"
],
"missing_questions": [
"carrier_trade_assc_cd",
"carrier_DG229_1",
"carrier_DG229_1",
"carrier_DG229_1"
]
}
],
"document_embeddings": {
"status": "Succeeded",
"start_time": "2026-10-24T20:17:10.291000",
"completed_time": "2026-10-24T20:18:18.344000",
"total_time": 68.034917
}
}